import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;

public class feladat {

    public feladat() {
    }

    //static PrintStream cerr = System.err;
    static final int MaxN = 100;

    static class Input {
        int N;
        int X;
        int F[][] = new int[MaxN][MaxN];
    }

    static class Output {
        boolean VAN;
        static int Y[] = new int[MaxN];
    }

    static class JoesetkeresesResponse {
        boolean VAN;
        int j;
    }

    static Input beolvas(IO io) throws IOException {
        Input input = new Input();
        input.N = io.nextInt();
        input.X = io.nextInt();
        for (int j = 0; j < input.N; j++) {
            for (int i = 0; i < input.N; i++) {
                input.F[j][i] = io.nextInt();
            }
        }
        return input;
    }

    static boolean rossz(int i, int j, int Y[]) {
        PrintStream cerr = System.err;
        int k = 1;
//        cerr.println("i:" + i);
        cerr.println("j:" + j);
//        cerr.println("k:" + k);
//        cerr.println("Y[k]:" + Y[k - 1]);
        while ((k < i) && (Y[k - 1] != j)) {
            k = k + 1;
//            cerr.println("k-:" + k);
        }
        cerr.println("k<i: " + k + "<" + i);
        return (k < i);
    }

    static JoesetkeresesResponse joesetkereses(int i, Input input, int Y[]) {
        PrintStream cerr = System.err;
        JoesetkeresesResponse response = new JoesetkeresesResponse();
        response.j = Y[i - 1] + 1;
        //cerr.println(j);
        while ((response.j <= input.N) && ((input.F[i - 1][response.j - 1] == 0) || rossz(i, response.j, Y))) {
            response.j = response.j + 1;
            //cerr.println(j);
        }
        cerr.println(i + "!" + response.j);
        response.VAN = (response.j <= input.N);
        return response;
    }

    static int Koltseg(Input input, int[] Y, int i, int j) {
        PrintStream cerr = System.err;
        int s = 0;
        for (int k = 1; k < i; k++) {
            s += ((Y[k - 1] > 0) ? input.F[k - 1][Y[k - 1] - 1] : 0);
        }
        s += input.F[i - 1][j - 1];
        cerr.println("k=" + s);
        return s;
    }

    static Output munkak(Input input) {
        PrintStream cerr = System.err;
        Output output = new Output();
        for (int i1 = 0; i1 < input.N; i1++) {
            output.Y[i1] = 0;
        }
        int i = 1;
        while ((i >= 1) && (i <= input.N)) {
            JoesetkeresesResponse joesetkeresesResponse = joesetkereses(i, input, output.Y);
            cerr.println(i + " - " + (joesetkeresesResponse.VAN ? ("v - " + joesetkeresesResponse.j) : "N"));
            if ((joesetkeresesResponse.VAN) && (Koltseg(input, output.Y, i, joesetkeresesResponse.j) <= input.X)) {
                output.Y[i - 1] = joesetkeresesResponse.j;
                i = i + 1;
            } else {
                output.Y[i - 1] = 0;
                i = i - 1;
            }
        }
        output.VAN = (i > input.N);
        return output;
    }

    static void kiir(IO io, Input input, Output output) throws IOException {
        if (output.VAN) {
            for (int i1 = 0; i1 < input.N; i1++) {
                io.write(output.Y[i1] + " ");
            }
            io.writeLn("");
        } else {
            io.writeLn("Nincs megoldas.");
        }
    }

    public static void main(String[] args) throws Exception {

        IO io = new IO();

        Input input = beolvas(io);

        Output output = munkak(input);

        kiir(io, input, output);

        io.close();

    }

}