import sys
'''
•	N – a munkák és a munkások száma
•	F – az adott munkások mely munkákhoz értenek (F[i,j] – az i. munkás által elvé-gezhető j. munka ára)
•	Y – az aktuálisan számolt megoldás: Y[i] az i. jelentkezőnek adott munka sor-száma
•	X – a rendelkezésre álló összeg

'''


def Beolvasás(): #soronként több számot vár
    sys.stderr.write("Kérem a munkások számát és a maximális összeget!) ");    
    sor=input().split()
    N=int(sor[0])
    X=int(sor[1])
    F=[0]*N   
    sys.stderr.write("Kérem az egyes munkások által vállalható munkákat fizetési igénnyel! ");    
    for i in range(N):
        sys.stderr.write(str(i+1)+". munkás:")
        sor=input().split()
        F[i]=[]
        for j in range(N):  
            F[i].append(int(sor[j]))
        
    return (X,F)  #N értékét megkaphatjuk F-ből

def Költség(Y,F,i):  
  s=0
  for j in range(i+1):
    s+=F[j][Y[j]]
  return s
 
def Rossz(Y,i,j):
  k=0
  while k<i and Y[k]!=j:
    k+=1
  return k<i

  
def Jóesetkeresés(Y,F,i):
  N=len(F)
  j=Y[i]+1
  while j<N and (Rossz(Y,i,j) or F[i][j]==0):
    j+=1
  Van=j<N
  return (Van,j)

  
def Munkák(X,F):
  i=0
  N=len(F)
  Y=[-1]*N                      #mivel 0-tól indexelünk
  while i>=0 and i<N:           #{lehet még és nincs még kész}
    (Van,j)=Jóesetkeresés(Y,F,i)
    if Van and Költség(Y,F,i)<=X:
        Y[i]=j
        i=i+1
    else:
        Y[i]=-1                 #jóesetben ehhez adunk egyet, így indulunk 0-tól!
        i=i-1                   #{visszalépés}
  Van=(i>=N)
  return (Van,Y)


def Kiirás(Van,Y):
    if Van:
      sys.stderr.write("Felvétel:")
      N=len(Y)
      for i in range(N):      
        print(Y[i]+1,end=" ")    #a kódban 0-tól indexeltünk  
    else:
        print("Nincs helyes megoldás.")
    
  
(X,F)=Beolvasás()
(Van,Y)=Munkák(X,F)
Kiirás(Van,Y)

    
