'''
Térképszínezés

•	N – a térkép területei száma
•	Sz – adott két terület szomszédos-e (Sz[i,j] – ha az i. és a j. terület szom-szédos, hamis egyébként)
•	Y – az aktuálisan számolt megoldás: Y[i] az i. terület színe
•	K – a használható színek száma

'''
import sys

def Beolvasás():
         
    sys.stderr.write("Hány terület van? ")
    N=int(input())
    Sz=[[]]  #0. indexű helyet most nem használjuk fel
   
    for i in range(1,N+1):
        Sz.append([0])          #0. helyet nem használjuk, 1-től lesznek az értékes adatok
        sys.stderr.write("Az "+str(i)+". terület határos-e rendre a többivel (0 nem, 1 igen) ")
        sor=input().split()        
        for j in range(1,N+1):
            hataros=sor[j-1]=="1"   #logikai érték
            Sz[i].append(hataros)   # a beolvasott értéket azonnal a listába illesztjük     
    return (N,Sz)      #elegendő lenne csak a listát visszaadni, a hosszt len() függvénnyel lekérdezhetjük  
        

def Térkép(N,Sz,K):
  i=1
  Y=[0]*(N+1)
  while i>=1 and i<=N:  # {lehet még és nincs még kész}
    (Van,j)=Jóesetkeresés(i,Sz,K,Y)
    if Van:
        Y[i]=j
        i+=1           #{előrelépés}
    else:
        Y[i]=0
        i-=1           #{visszalépés}
  Van=(i>N)
  return (Van,Y)

def Jóesetkeresés(i,Sz,K,Y):
  j=Y[i]+1
  while j<=K and Rossz(i,j,Sz,Y):
    j+=1
  Van=(j<=K)
  return (Van,j)

def Rossz(i,j,Sz,Y):
  k=1
  while k<i and (Y[k]!=j or not Sz[k][i]):
    k+=1
  rossz=(k<i)
  return rossz
    
def Kiirás(Van,Y):
   if Van:
       Y=Y[1:]          #elhagyjuk az első elemet, amiben nincs értékes adat
       print(" ".join(str(y) for y  in Y)) #összefűzzük a listát elemenként
   else:
       print("NINCS")
    
(N,Sz)=Beolvasás()
(Van,Y)=Térkép(N,Sz,4)
Kiirás(Van,Y)
